
-- Mount Indexes!! 1 = very slow, 2 = travel/ghost wolf, 3 = ground, 4 = aq, 5 = vashj, 6 = fly, 7 = fly+ground 

--		spell (EN),							is mount/speedindex,	fly-speed,		in:combat		in:air			outlandonly		icon
--															ground-speed,	water-speed,	in:water		on:ground		can indoor				instant

SmartMount.InitSpells = {
		-- death knight
		{[0]=[[Path of Frost]],				3714,	false,	100,	false,	100,	false,	true,	false,	false,	false,	false,	'Interface\\Icons\\Spell_DeathKnight_PathOfFrost', true},
		-- hunter
		{[0]=[[Aspect of the Cheetah]],		5118,	false,	130,	false,	66	,	true,	true,	false,	true,	false,	true,	'Interface\\Icons\\Ability_Mount_JungleTiger', true},
		{[0]=[[Aspect of the Pack]],		13159,	false,	130,	false,	66	,	true,	true,	false,	true,	false,	true,	'Interface\\Icons\\Ability_Mount_WhiteTiger', true},
		{[0]=[[Aspect of the Viper]],		38390,	false,	100,	false,	66	,	true,	true,	false,	true,	false,	true,	'Interface\\Icons\\Ability_Hunter_AspectoftheViper', true},
		-- mage
		{[0]=[[Blink]],						1953,	false,	false,	false,	false,	true,	true,	true,	true,	false,	true,	'Interface\\Icons\\Ability_Ambush', true},
		{[0]=[[Slow Fall]],					130,	false,	100,	100,	false,	false,	false,	true,	true,	false,	true,	'Interface\\Icons\\Spell_Magic_FeatherFall', true},
		-- priest
		{[0]=[[Levitate]],					1706,	false,	100,	100,	100,	false,	true,	true,	true,	false,	true,	'Interface\\Icons\\Spell_Holy_LayOnHands', true},
		-- rogue
		{[0]=[[Sprint]],					2983,	false,	150,	false,	false,	true,	false,	false,	true,	false,	false,	'Interface\\Icons\\Ability_Rogue_Sprint', true},
		-- shaman
		{[0]=[[Ghost Wolf]],				2645,	2,		140,	false,	66,		true,	true,	false,	true,	false,	true,	'Interface\\Icons\\Spell_Nature_SpiritWolf', false},
		{[0]=[[Water Breathing]],			131,	false,	100,	false,	66,		false,	true,	false,	false,	false,	true,	'Interface\\Icons\\Spell_Shadow_Demonbreath', true},
		{[0]=[[Water Walking]],				546,	false,	100,	false,	100,	false,	true,	false,	false,	false,	false,	'Interface\\Icons\\Spell_Frost_WindWalkOn', true},
		-- warlock
		{[0]=[[Unending Breath]],			5697,	false,	100,	false,	66,	false,	true,	false,	false,	false,	true,	'Interface\\Icons\\Spell_Shadow_Demonbreath', true},

		-- nightelf
		{[0]=[[Shadowmeld]],				58984,	false,	false,	false,	false,	true,	true,	false,	true,	false,	true,	'Interface\\Icons\\Ability_Ambush', true},
	}

SmartMount.InitShapeshifts = {
		{'Bear Form',			false,	100,	false,	66,		true,	true,	false,	true,	false,	true,	'Interface\\Icons\\Ability_Racial_BearForm'},
		{'Aquatic Form',		false,	false,	false,	100,	true,	true,	false,	false,	false,	true,	'Interface\\Icons\\Ability_Druid_AquaticForm'},
		{'Cat Form',			false,	100,	false,	66,		true,	true,	false,	true,	false,	true,	'Interface\\Icons\\Ability_Druid_CatForm'},
		{'Travel Form',			2,		140,	false,	false,	true,	false,	false,	true,	false,	false,	'Interface\\Icons\\Ability_Druid_TravelForm'},
		{'Moonkin Form',		false,	100,	false,	66,		true,	true,	false,	true,	false,	true,	'Interface\\Icons\\Spell_Nature_ForceOfNature'},
		{'Tree of Life',		false,	100,	false,	66,		true,	true,	false,	true,	false,	true,	'Interface\\Icons\\Ability_Druid_TreeofLife'},
		{'Flight Form',			6,		false,	160,	false,	false,	false,	true,	true,	true,	false,	'Interface\\Icons\\Ability_Druid_FlightForm'},
		{'Swift Flight Form',	6,		false,	380,	false,	false,	false,	true,	true,	true,	false,	'Interface\\Icons\\Ability_Druid_FlightForm'},
	}

function SmartMount:InitClick()
	self.InitedClick = true

	self.SpecialSpells = {}

	-- setup the variable mounts!!
	if FindSpellBookSlotBySpellID(90265) then -- Master Riding
		self.CanRide = true
		self.CanFly = true
	elseif FindSpellBookSlotBySpellID(34091) then -- Artisan Riding
		self.CanRide = true
		self.CanFly = true
	elseif FindSpellBookSlotBySpellID(34090) then -- Expert Riding
		self.CanRide = true
		self.CanFly = true
	elseif FindSpellBookSlotBySpellID(33391) then -- Journeyman Riding
		self.CanRide = true
		self.CanFly = false
	elseif FindSpellBookSlotBySpellID(33388) then -- Apprentice Riding
		self.CanRide = true
		self.CanFly = false
	else
		self.CanRide = false
		self.CanFly = false
	end -- if

	self.FlyZones = {[1]=false, [2]=false, [3]=false, [4]=false, [5]=false}
	if self.CanFly then
		self.FlyZones[3] = true
		
		if FindSpellBookSlotBySpellID(54197) then
			-- cold weather flying
			self.FlyZones[4] = true
		end -- if

		if FindSpellBookSlotBySpellID(90267) then
			-- azeroth flying
			self.FlyZones[0] = true -- pre instance zones
			self.FlyZones[1] = true
			self.FlyZones[2] = true
			self.FlyZones[5] = true -- deepholm
		end -- if
	end -- if
	-- /setup
	
	-- check for spells...
	for _, spell in pairs(self.InitSpells) do
		local locspell = GetSpellInfo(spell[1])
		
		self.SpecialSpells['spell:' .. spell[0]] = {
			type = 'spell',
			spell = locspell,
			name = locspell,
			can = FindSpellBookSlotBySpellID(spell[1]),
			mount = spell[2],
			land = spell[3],
			fly = spell[4],
			swim = spell[5],
			incombat = spell[6],
			inwater = spell[7],
			inair = spell[8],
			onground = spell[9],
			--outlandonly = spell[10],
			inhouse = spell[11],
			icon = spell[12],
			instant = spell[13],
		}
	end -- for
	
	local _, myclass = UnitClass('player')
	if myclass == 'SHAMAN' then
		-- I'm an Shaman
		local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(self.SpellLocale['Ghost Wolf'])
		if castTime == 0 then
			self.SpecialSpells['spell:Ghost Wolf'].instant = true
		end -- if
	end -- if
	
	-- check for shapeshift forms
	for _, spell in pairs(self.InitShapeshifts) do
		local locspell = self.SpellLocale[spell[1]]

		local can = false
		for i=1, GetNumShapeshiftForms() do
			local _,name, _ = GetShapeshiftFormInfo(i)
			if name == locspell then
				can = true
			end -- if
		end -- for
		self.SpecialSpells['spell:' .. spell[1]] = {
			type = 'spell',
			spell = locspell,
			name = locspell,
			can = can,
			mount = spell[2],
			land = spell[3],
			fly = spell[4],
			swim = spell[5],
			incombat = spell[6],
			inwater = spell[7],
			inair = spell[8],
			onground = spell[9],
			--outlandonly = spell[10],
			inhouse = spell[11],
			icon = spell[12],
			instant = true,
		}
	end -- for
	
	-- special enties
	self.SpecialSpells['special:instantform'] = {
		type = 'special',
		name = SmartMount_Locale['Travel, Flight or Swift Flight Form'],
		can = self.SpecialSpells['spell:Travel Form'].can,
		mount = 2,
		land = 140,
		fly = false,
		swim = false,
		incombat = false,
		inwater = false,
		inair = false,
		onground = true,
		inhouse = false,
		icon = 'Interface\\Icons\\Ability_Hunter_Pathfinding',
	}
	
	-- 'join' flight form
	if self.SpecialSpells['spell:Swift Flight Form'].can then
		-- just say, that the Flight Form has speed 6, and another spell...
		self.SpecialSpells['spell:Flight Form'].spell = self.SpecialSpells['spell:Swift Flight Form'].spell
		self.SpecialSpells['spell:Flight Form'].mount = self.SpecialSpells['spell:Swift Flight Form'].mount
		self.SpecialSpells['spell:Flight Form'].fly = self.SpecialSpells['spell:Swift Flight Form'].fly
		self.SpecialSpells['spell:Flight Form'].can = true
	end
	self.SpecialSpells['spell:Flight Form'].name = SmartMount_Locale['Flight / Swift Flight Form']
	self.SpecialSpells['spell:Swift Flight Form'] = nil
	
	-- Hook of the Master Angler
	self.SpecialSpells['special:Hook of the Master Angler'] = {
		type = 'item',
		item = 'item:19979:0:0:0:0:0:0:',
		name = self.SpellLocale['Hook of the Master Angler'],
		spell = self.SpellLocale['Hook of the Master Angler'],
		can = self:WearItem('item:19979:'),
		mount = false,
		land = false,
		fly = false,
		swim = 100,
		incombat = true,
		inwater = true,
		inair = false,
		onground = false,
		inhouse = false,
		icon = [[Interface\Icons\Trade_Fishing]],
		instant = true,
	}
	
	-- Parachute Cloak
	self.SpecialSpells['special:Parachute Cloak'] = {
		type = 'item',
		item = 'item:10518:0:0:0:0:0:0:',
		name = self.SpellLocale['Parachute Cloak'],
		spell = self.SpellLocale['Parachute Cloak'],
		can = self:WearItem('item:10518:'),
		mount = false,
		land = false,
		fly = 100,
		swim = false,
		incombat = true,
		inwater = false,
		inair = true,
		onground = false,
		inhouse = false,
		icon = [[Interface\Icons\INV_Misc_Cape_11]],
		instant = true,
	}
	
	-- Hearthstone
	self.SpecialSpells['special:Hearthstone'] = {
		type = 'item',
		item = 'item:6948:0:0:0:0:0:0:',
		name = self.SpellLocale['Hearthstone'],
		spell = self.SpellLocale['Hearthstone'],
		can = true,
		mount = false,
		land = false,
		fly = false,
		swim = false,
		incombat = true,
		inwater = true,
		inair = false,
		onground = true,
		inhouse = true,
		icon = [[Interface\Icons\INV_Misc_Rune_01]],
		instant = false,
	}
	
	-- Astral Recall
	self.SpecialSpells['special:Astral Recall'] = {
		type = 'spell',
		name = self.SpellLocale['Astral Recall'],
		spell = self.SpellLocale['Astral Recall'],
		can = myclass == 'SHAMAN',
		mount = false,
		land = false,
		fly = false,
		swim = false,
		incombat = true,
		inwater = true,
		inair = false,
		onground = true,
		inhouse = true,
		icon = [[Interface\Icons\Spell_Nature_AstralRecal]],
		instant = false,
	}
	
	if self.rock then
		-- update the ListOfMountsCache (profile)
		-- and generate the self.ListOfMounts

		self.ListOfMounts = {}
	
		-- count the mounts I have	
		local mounts = self:CountMounts(true, false, true)
		for i, _ in pairs(mounts) do
			for _, v in pairs(mounts[i]) do
				local _, itemName, _, itemTexture, _ = GetCompanionInfo("MOUNT", v.slot)
				if type(itemName) ~= 'string' then
					self:dump('mounts['..i..']', v)
					self:dump('itemName', itemName)
					self:dump('itemTexture', itemTexture)
				else
					-- update cache
					self:GetPref('ListOfMountsCache')[v.action] = (-i)..':'..itemName
					--self:SetTablePref('ListOfMountsCache', v.action, i..':'..itemName)
					-- set list
					self.ListOfMounts[v.action] = {
						type = 'MOUNT',
						action = v.action,
						name = itemName,
						slot = v.slot,
						can = true,
	-- Mount Indexes!! 1 = very slow, 2 = travel/ghost wolf, 3 = ground, 4 = aq, 5 = vashj, 6 = fly, 7 = fly+ground 
						mount = i,
						land = (i <= 4) or (i == 7),
						fly = (i == 6) or (i == 7),
						swim = false,
						incombat = false,
						inwater = true,
						inair = false,
						onground = true,
						inhouse = false,
						icon = itemTexture,
					}
				end -- if
			end -- for
		end -- for
	
		for k,v in pairs(self:GetPref('ListOfMountsCache')) do
			local found, _, speed, name = string.find(v, '(%d+):(.*)')
			if found then
				speed = tonumber(speed)
			end -- if
			if not found or string.sub(k, 1, 6) ~= 'MOUNT:' or speed >= 0 then
				self:GetPref('ListOfMountsCache')[k] = nil
				--self:SetTablePref('ListOfMountsCache', k, nil)
			elseif self.ListOfMounts[k] == nil then
				self.ListOfMounts[k] = {
					action = k,
					name = name,
					spell = name,
					can = false,
					mount = -speed,
					land = false, --mountspeed[tonumber(speed)][1],
					fly = false, --mountspeed[tonumber(speed)][2],
					swim = false,
					incombat = false,
					inwater = true,
					inair = false,
					onground = true,
					inhouse = false,
					icon = nil,
				}
				-- we can set icon/spell to nil, because of 'can=false'
			end -- if
		end -- for
	
		for k, v in pairs(self.SpecialSpells) do
			v['action'] = k
			self.ListOfMounts[k] = v
		end -- for
		
		for k,v in pairs(self.ListOfMounts) do
			if not v['can'] then
				if string.sub(k, 1, 5) == 'item:' then
					v['icon'] = 'Interface\\AddOns\\SmartMount\\Icons\\Mount_Item'
				elseif k == 'special:Hook of the Master Angler' then
					v['icon'] = 'Interface\\AddOns\\SmartMount\\Icons\\Special_Hook'
				elseif (v.land and v.land > 100) or (v.fly and v.fly > 100) then
					v['icon'] = 'Interface\\AddOns\\SmartMount\\Icons\\Mount_Spell'
				else
					v['icon'] = 'Interface\\AddOns\\SmartMount\\Icons\\Spell'
				end -- if
			end -- if
		end -- do
	end
	
	local hasinstant = false
	for _,v in pairs(self.SpecialSpells) do
		if v.instant then
			hasinstant = true
		end -- if
	end
		self:dump('hasinstant', hasinstant)
	
	self:PostClick('LeftButton')
	self:PostClick('RightButton')
	self:PostClick('MiddleButton')
	
end

function SmartMount:HijackBindings(showmessage)
    self:dump('hijack');
	
	if showmessage then
		DEFAULT_CHAT_FRAME:AddMessage('|cff3fcf26SmartMount|r: Please press the key again to use SmartMount.')
	end -- if

	-- normal bindings
	ClearOverrideBindings(SmartMount_Button)
	
	local key1, key2 = GetBindingKey('SMARTMOUNT_MOUNTORCONFIG')
	if key1 then
		SetOverrideBindingClick(SmartMount_Button, true, key1, 'SmartMount_Button', 'LeftButton')
	end --if
	if key2 then
		SetOverrideBindingClick(SmartMount_Button, true, key2, 'SmartMount_Button', 'LeftButton')
	end --if
end


function SmartMount:PreClick(btn, button)
self:dump('pc', btn)
	local config

	if btn == 'MiddleButton' then
		config = 3
	elseif btn == 'RightButton' then
		config = 2
	else -- if btn == 'LeftButton' then
		config = 1
	end -- if

	local mounted = nil
	
	if CanExitVehicle() then
		mounted = 'vehicle'
	elseif IsMounted() then
		mounted = 'regular'
	end -- if
	
	for _, spell in pairs(self.SpecialSpells) do
		if spell['spell'] and spell['mount'] and UnitBuff('player', spell['spell']) then
			mounted = spell['spell']
		end -- if
	end -- for

	local name, mode
	if InCombatLockdown() then
		name = 'combat'
	elseif IsSwimming() then
		name = 'swim'
	elseif IsFlying() or IsFalling() then
		name = 'fly'
	else
		name = 'land'
	end -- if
	
	local _, myclass = UnitClass('player')
	if not mounted and myclass == 'DRUID' then
		for i=1, GetNumShapeshiftForms() do
			local _, name, active, _ = GetShapeshiftFormInfo(i)
			self:dump(i, {name, active})
			if active then
				mounted = name
			end -- if
		end -- for
	end -- if

	self:dump('preclick', {cfg = config, name = name, mounted = mounted})

	if mounted then
		mode = 'dis'
		
		if not self:GetPref('c'..config..'-'..name..'-dis-do') then
			-- cancel here, cause we would'nt dismount
			if name ~= 'combat' then
				-- if in combat: don't change button; otherwise: don't do anything
				self:SetAttributes(config, {})
			end -- if
			return
		end
	
		if name == 'fly' and self:GetPref('c'..config..'-'..name..'-dis-do-groundonly') and IsFlying() then
			-- cancel here, cause we would'nt dismount
			self:SetAttributes(config, {})
			return
		end
	
	    if mounted == 'regular' then
			Dismount()
		elseif mounted == 'vehicle' then
			if not self:GetPref('ExitVehicle') then
				self:SetAttributes(config, {})
				return
			end -- if
			VehicleExit()
		else
--			CancelUnitBuff('player', mounted)
			self:SetAttributes(config, {type='spell', spell=mounted})
			return
		end -- if
	else
		mode = 'mnt'
	end -- if
	
	self:dump('preclick-mode:', mode)
	
	if name == 'combat' then
		-- cancel here, cause we can't do anything
		return
	end -- if
		
	local chgbutton = self:GetMount('c'..config..'-'..name..'-'..mode..'-try', name, false) or {}
	-- or => if nothing found: nothing

	self:dump('preclick-button', chgbutton)
	
	self:SetAttributes(config, chgbutton, button)
end

function SmartMount:PostClick(btn, button)
	if btn == 'MiddleButton' then
		config = 3
	elseif btn == 'RightButton' then
		config = 2
	else -- if btn == 'LeftButton' then
		config = 1
	end -- if
	self:dump('postclick', config)

	if not InCombatLockdown() then
		local chgbutton = self:GetMount('c'..config..'-combat-mnt-try', 'combat', true) or {}
		-- or => if nothing found: nothing

		self:dump('postclick-button', chgbutton)
	
		self:SetAttributes(config, chgbutton, button)
	end
end

function SmartMount:SetAttributes(config, attr, button)
	local buttons
	if button == nil then
		buttons = self.Buttons
	else
		buttons = { button }
	end -- if
	for _, btn in pairs(buttons) do
		if attr['type'] == 'MOUNT' or attr['type'] == 'CRITTER' then
			CallCompanion(attr['type'], attr['slot'])
			btn:SetAttribute('type'..config, nil)
			btn:SetAttribute('spell'..config, nil)
			btn:SetAttribute('item'..config, nil)
			btn:SetAttribute('unit'..config, nil)
		else
			btn:SetAttribute('type'..config, attr['type'])
			btn:SetAttribute('spell'..config, attr['spell'])
			btn:SetAttribute('item'..config, attr['item'])
			btn:SetAttribute('unit'..config, 'player')
		end -- if
	end -- for
end

-- some tables for mount-checking

-- Mount Indexes!! 1 = very slow, 2 = travel/ghost wolf, 3 = ground, 4 = aq, 5 = vashj, 6 = fly, 7 = fly+ground 
local MountTable_FlyFirst = {
	6, 4, 3, 2, 1,
}

local MountTable_GroundOnly = {
	4, 3, 2, 1,
}

function SmartMount:MyUnit()
	if UnitInVehicle('player') then
		return 'vehicle'
	else
		return 'player'
	end -- if
end

function SmartMount:xor(a, b)
	return (a and not b) or (not a and b)
end

function SmartMount:GetRandomPet()
	local continent = 0
	local zone = GetZoneText()
	for con, _ in pairs({GetMapContinents()}) do
		for _,name in pairs({GetMapZones(con)}) do
			if(name == zone) then
				continent = con
			end -- if
		end -- for
	end -- for
	if continent == 0 then
		-- no known continent -> maybe in a dungeon -> don't call a pet
		return
	end -- if

	local useable = {}
	for slot = 1 , GetNumCompanions('CRITTER') do
		local _, _, creatureSpellID, _, issummoned = GetCompanionInfo('CRITTER', slot)
		if not issummoned and not self:xor(self:GetPlayerPref('ExcludedMiniPetsWhitelist'), self:GetPlayerPref('ExcludedMiniPets')[creatureSpellID]) then
			table.insert(useable, {
				type = 'CRITTER',
				slot = slot,
			})
		end -- if
	end -- for
	if #useable > 0 then
		return useable[math.random(#useable)]
	end -- if
	return nil
end

function SmartMount:GetMount(prefix, name, ignoremoving)
	local IsMoving = GetUnitSpeed(self:MyUnit()) > 0
	if ignoremoving then
		IsMoving = false
	end
	
	local zone = GetZoneText()
	local allowed = self:GetAllowedSpeeds()
	
	for i=1, 3 do
		local mount = self:GetPref(prefix .. i)

		--self:dump(prefix..i..name, mount)

		local result = nil
		if not mount or mount == 'off' then
			return nil -- found nothing: do nothing
		elseif (mount == 'rnd_fast' or mount == 'rnd_fast2') and IsOutdoors() then
			-- 'rnd_fast2' for legacy reasons
			result = self:GetRandomMount(allowed, IsMoving, MountTable_FlyFirst)
		elseif mount == 'rnd_fast3' and IsOutdoors() then
			result = self:GetRandomMount(allowed, IsMoving, MountTable_GroundOnly)
		elseif mount == 'rnd_all' and IsOutdoors() then
			result = self:GetAnyRandomMount(allowed, IsMoving)
		elseif mount == 'rnd_pet' then
			result = self:GetRandomPet()
		elseif string.sub(mount, 1, 5) == 'item:' then
			if self:WearItem(mount) then
				result = {
					type = 'item',
					item = mount,
				}
			end -- if
		elseif ( string.sub(mount, 1, 6) == 'MOUNT:' and IsOutdoors() and not IsMoving ) or string.sub(mount, 1, 8) == 'CRITTER:' then
			self:dump(mount, self.ListOfMounts[mount])
			if self.ListOfMounts[mount].can and allowed[self.ListOfMounts[mount].mount] then
				result = {
					type = self.ListOfMounts[mount].type,
					slot = self.ListOfMounts[mount].slot,
				}
			end -- if
		elseif self.SpecialSpells[mount] then
			-- something special (which is in SpecialSpells)
			if 
				(
					(self.SpecialSpells[mount].type == 'spell' and self.SpecialSpells[mount].can) or
					(self.SpecialSpells[mount].type == 'item' and self:WearItem(self.SpecialSpells[mount].item))
				)
					and
				(
					allowed[self.ListOfMounts[mount].mount]
				)
					and
				(
					self.SpecialSpells[mount].inhouse or IsOutdoors()
				)
					and
				(
					self.SpecialSpells[mount].instant or not IsMoving
				)
					and
				(
					(name == 'swim' and self.SpecialSpells[mount].inwater) or
					(name == 'fly' and self.SpecialSpells[mount].inair) or
					(name == 'land' and self.SpecialSpells[mount].onground) or
					(name == 'combat' and self.SpecialSpells[mount].incombat)
				)
			then
				result = self.SpecialSpells[mount]
			end -- if
		end -- if
		if result then
			return result
		end -- if
	end
	return nil
end

function SmartMount:GetRandomMount(allowed, IsMoving, tab)
	-- get 'regular' mounts
	local mounts = self:CountMounts(false, IsMoving)
	
	self:dump('mounts_avail', mounts)
	self:dump('allowed', allowed)
	self:dump('tab', tab)
	
	-- pick speed category
	for _, speedtab in pairs(tab) do
		if type(speedtab) ~= 'table' then
			speedtab = {speedtab}
		end -- if
		local joinedtab = {}
		for _, speed in pairs(speedtab) do
			if allowed[speed] and #(mounts[speed]) > 0 then
				for _, v in pairs(mounts[speed]) do
					table.insert(joinedtab, v)
				end -- for
			end -- for
		end -- if
		if #(joinedtab) > 0 then
			self:dump('mounts_sele', joinedtab)
			return self:PickGroupedMount(joinedtab)
		end -- if
	end -- for
	
	return nil
end

function SmartMount:GetAnyRandomMount(allowed, IsMoving)
	-- get 'regular' mounts
	local mounts = self:CountMounts(false, IsMoving)
	
	self:dump('mounts_biglist', mounts)
	
	local biglist = {}
	
	-- pick speed category
	for speed, _ in pairs(mounts) do
		if allowed[speed] then
			for _, v in pairs(mounts[speed]) do
				table.insert(biglist, v)
			end -- for
		end -- if
	end -- for
	
	return self:PickGroupedMount(biglist)
end

function SmartMount:PickGroupedMount(list)
	if #list == 0 then
		return nil
	end -- if
	
	local groups, groupids = {}, {}
	for _, v in pairs(list) do
		local id = self.Groups[v.companionid] or v.companionid or -(#groups)
		-- -(#gorups) generates a new group for everything whithout an companionid
		if groups[id] == nil then
			groups[id] = {}
			table.insert(groupids, id)
		end -- if
		table.insert(groups[id], v)
	end -- for
	
	self:dump('mounts_groups', groups)
	local group = groups[groupids[math.random(#groupids)]]
	self:dump('mounts_group', group)
	return group[math.random(#group)]
end

function SmartMount:CountMounts(withoutSpells, IsMoving, noExcl)
-- Mount Indexes!! 1 = very slow, 2 = travel/ghost wolf, 3 = ground, 4 = aq, 5 = vashj, 6 = fly, 7 = fly+ground 
	local mounts = { [1]={}, [2]={}, [3]={}, [4]={}, [5]={}, [6]={}  }
	local excl = noExcl or self:GetPlayerPref('ExcludedMounts')

	if not IsMoving then
		for slot = 1, GetNumCompanions("MOUNT") do
			local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", slot)
			--self:dump('mount', {creatureID, creatureName, creatureSpellID, issummoned})
			if noExcl or not self:xor(self:GetPlayerPref('ExcludedMountsWhitelist'), excl[creatureSpellID]) then
				-- only if not excluded by the user
				local speed = self.Mounts[tonumber(creatureSpellID)]
				if speed == 7 then
					-- ground and flying mount
					table.insert(mounts[3], { type = 'MOUNT', slot = slot, companionid =  creatureSpellID, action = 'MOUNT:' .. creatureSpellID} )
					if self.CanFly then
						table.insert(mounts[6], { type = 'MOUNT', slot = slot, companionid =  creatureSpellID, action = 'MOUNT:' .. creatureSpellID} )
					end -- if
				elseif speed then
					table.insert(mounts[speed] or mounts[1], { type = 'MOUNT', slot = slot, companionid =  creatureSpellID, action = 'MOUNT:' .. creatureSpellID} )
				end -- if
			end -- if
		end -- for
	end -- if
	
	if not withoutSpells then
		for name, spell in pairs(self.SpecialSpells) do
			if spell.can and spell['mount'] and ( spell.instant or not IsMoving ) then
				table.insert(mounts[spell['mount']], spell)
			end -- if
		end -- for
	end -- if

	return mounts
end

function SmartMount:WearItem(item)
	-- search in bags
	for bag = 0, NUM_BAG_FRAMES do
		for slot = 1, GetContainerNumSlots(bag) do
			local link = GetContainerItemLink(bag, slot)
			if link and string.find(link, item) then
				return true
			end -- if
		end -- for
	end -- for
	
	-- search on me
	for slot = 1, 39 do
		local link = GetInventoryItemLink('player', slot)
		if link and string.find(link, item) then
			return true
		end -- if
	end -- for
	return false
end

-- Mount Indexes!! 1 = very slow, 2 = travel/ghost wolf, 3 = ground, 4 = aq, 5 = vashj, 6 = fly, 7 = fly+ground 
function SmartMount:GetAllowedSpeeds()
	local allowed = {}
	
	allowed[false] = true -- dummy entry for spells
	allowed[2] = true -- travel form / ghost wolf
	
	for _, v in pairs({self.libMounts:GetCurrentMountType()}) do
		if v == self.libMounts.AIR then
			allowed[6] = true
			allowed[7] = true
		elseif v == self.libMounts.GROUND then
			allowed[1] = true
			allowed[3] = true
		--elseif v == self.libMounts.WATER then
		--	allowed[?] = true
		elseif v == self.libMounts.AHNQIRAJ then
			allowed[4] = true
		elseif v == self.libMounts.VASHJIR then
			allowed[5] = true
		end -- if
	end -- for
	
	return allowed
end

function SmartMount:CanMountHere(zone, subzone)
	--if zone == self.SpellLocale['Dalaran Arena'] then
	--	return false
	--end -- if
	return true
end

function SmartMount:CanFlyHere(zone, subzone)
	-- get continent
	local continent = 0
	for con, _ in pairs({GetMapContinents()}) do
		for _,name in pairs({GetMapZones(con)}) do
			if(name == zone) then
				continent = con
			end -- if
		end -- for
	end -- for
	
	self:dump('CanFlyHere.continent', continent)
	
	if not self.FlyZones[continent] then
		return false
		-- we have no spell to fly here
	end -- if
	
	-- wintergrasp special
	if zone == self.SpellLocale['Wintergrasp'] then
		return GetWintergraspWaitTime()
	end -- if
	
	-- general
	return IsFlyableArea()
end

-- Mount Indexes!! 1 = very slow, 2 = travel/ghost wolf, 3 = ground, 4 = aq, 5 = vashj, 6 = fly, 7 = fly+ground 
SmartMount.Mounts = {}
setmetatable(SmartMount.Mounts, {
	__index = function(t,id)
		local ground, air, water, speed, location = SmartMount.libMounts:GetMountInfo(id)
		local result = false
		if location == SmartMount.libMounts.AHNQIRAJ then
			-- AQ only mount
			result = 4
		elseif location == SmartMount.libMounts.VASHJIR then
			-- VASHJIR only mount
			result = 5
		elseif location then
			-- any other special mount
			-- ignore it
		elseif speed then
			-- special speed -> slowest mount category
			result = 1
		elseif ground and air then
			result = 7
		elseif ground then
			result = 3
		elseif air then
			result = 6
		else
			-- unkonown -> ignore
		end -- if
		
		-- cache result
		t[id] = result
		
		return result
	end -- function
})

SmartMount.Groups = {
	[458] = 458, -- Brown Horse Bridle, Lvl 30
	[470] = 458, -- Black Stallion Bridle, Lvl 30
	[472] = 458, -- Pinto Bridle, Lvl 30
	[6648] = 458, -- Chestnut Mare Bridle, Lvl 30
	[580] = 580, -- Horn of the Timber Wolf
	[6653] = 580, -- Horn of the Dire Wolf
	[6654] = 580, -- Horn of the Brown Wolf
	[6777] = 6777, -- Gray Ram
	[6898] = 6777, -- White Ram
	[6899] = 6777, -- Brown Ram
	[6896] = 6896, -- Harness: Black Ram
	[6897] = 6896, -- Harness: Blue Ram
	[8394] = 8394, -- Reins of the Striped Frostsaber
	[10789] = 8394, -- Reins of the Spotted Frostsaber
	[10793] = 8394, -- Reins of the Striped Nightsaber
	[8395] = 8395, -- Whistle of the Emerald Raptor
	[10796] = 8395, -- Whistle of the Turquoise Raptor
	[10799] = 8395, -- Whistle of the Violet Raptor
	[10873] = 10873, -- Red Mechanostrider
	[10969] = 10873, -- Blue Mechanostrider
	[17453] = 10873, -- Green Mechanostrider
	[17454] = 10873, -- Unpainted Mechanostrider
	[16080] = 16080, -- Horn of the Red Wolf
	[16081] = 16080, -- Horn of the Arctic Wolf
	[17460] = 17460, -- Frost Ram
	[17461] = 17460, -- Black Ram
	[17462] = 17462, -- Red Skeletal Horse
	[17463] = 17462, -- Blue Skeletal Horse
	[17464] = 17462, -- Brown Skeletal Horse
	[17465] = 17465, -- Green Skeletal Warhorse
	[23246] = 17465, -- Purple Skeletal Warhorse
	[18989] = 18989, -- Gray Kodo
	[18990] = 18989, -- Brown Kodo
	[18991] = 18991, -- Green Kodo
	[18992] = 18991, -- Teal Kodo
	[23219] = 23219, -- Reins of the Swift Mistsaber
	[23221] = 23219, -- Reins of the Swift Frostsaber
	[23338] = 23219, -- Reins of the Swift Stormsaber
	[23222] = 23222, -- Swift Yellow Mechanostrider
	[23223] = 23222, -- Swift White Mechanostrider
	[23225] = 23222, -- Swift Green Mechanostrider
	[23227] = 23227, -- Swift Palomino, Lvl 60
	[23228] = 23227, -- Swift White Steed
	[23229] = 23227, -- Swift Brown Steed
	[23238] = 23238, -- Swift Brown Ram
	[23239] = 23238, -- Swift Gray Ram
	[23240] = 23238, -- Swift White Ram
	[43900] = 23238, -- Swift Brewfest Ram
	[23241] = 23241, -- Swift Blue Raptor
	[23242] = 23241, -- Swift Olive Raptor
	[23243] = 23241, -- Swift Orange Raptor
	[24242] = 23241, -- Swift Razzashi Raptor
	[23247] = 23247, -- Great White Kodo
	[23248] = 23247, -- Great Gray Kodo
	[23249] = 23247, -- Great Brown Kodo
	[49379] = 23247, -- Great Brewfest Kodo
	[23250] = 23250, -- Horn of the Swift Brown Wolf
	[23251] = 23250, -- Horn of the Swift Timber Wolf
	[23252] = 23250, -- Horn of the Swift Gray Wolf
	[25953] = 25953, -- Blue Qiraji Resonating Crystal
	[26054] = 25953, -- Red Qiraji Resonating Crystal
	[26055] = 25953, -- Yellow Qiraji Resonating Crystal
	[26056] = 25953, -- Green Qiraji Resonating Crystal
	[32235] = 32235, -- Golden Gryphon
	[32239] = 32235, -- Ebon Gryphon
	[32240] = 32235, -- Snowy Gryphon
	[32242] = 32242, -- Swift Blue Gryphon
	[32289] = 32242, -- Swift Red Gryphon
	[32290] = 32242, -- Swift Green Gryphon
	[32292] = 32242, -- Swift Purple Gryphon
	[32243] = 32243, -- Tawny Wind Rider
	[32244] = 32243, -- Blue Wind Rider
	[32245] = 32243, -- Green Wind Rider
	[32246] = 32246, -- Swift Red Wind Rider
	[32295] = 32246, -- Swift Green Wind Rider
	[32296] = 32246, -- Swift Yellow Wind Rider
	[32297] = 32246, -- Swift Purple Wind Rider
	[33660] = 33660, -- Swift Pink Hawkstrider
	[35025] = 33660, -- Swift Green Hawkstrider
	[35027] = 33660, -- Swift Purple Hawkstrider
	[46628] = 33660, -- Swift White Hawkstrider
	[34406] = 34406, -- Brown Elekk
	[35710] = 34406, -- Gray Elekk
	[35711] = 34406, -- Purple Elekk
	[34790] = 34790, -- Reins of the Dark War Talbuk
	[34896] = 34790, -- Reins of the Cobalt War Talbuk
	[34897] = 34790, -- Reins of the White War Talbuk
	[34898] = 34790, -- Reins of the Silver War Talbuk
	[34899] = 34790, -- Reins of the Tan War Talbuk
	[39315] = 39315, -- Reins of the Cobalt Riding Talbuk
	[39316] = 39315, -- Reins of the Dark Riding Talbuk
	[39317] = 39315, -- Reins of the Silver Riding Talbuk
	[39318] = 39315, -- Reins of the Tan Riding Talbuk
	[39319] = 39315, -- Reins of the White Riding Talbuk
	[34795] = 34795, -- Red Hawkstrider
	[35018] = 34795, -- Purple Hawkstrider
	[35020] = 34795, -- Blue Hawkstrider
	[35022] = 34795, -- Black Hawkstrider
	[35712] = 35712, -- Great Green Elekk
	[35713] = 35712, -- Great Blue Elekk
	[35714] = 35712, -- Great Purple Elekk
	[39798] = 39798, -- Green Riding Nether Ray
	[39800] = 39798, -- Red Riding Nether Ray
	[39801] = 39798, -- Purple Riding Nether Ray
	[39802] = 39798, -- Silver Riding Nether Ray
	[39803] = 39798, -- Blue Riding Nether Ray
	[41513] = 41513, -- Reins of the Onyx Netherwing Drake
	[41514] = 41513, -- Reins of the Azure Netherwing Drake
	[41515] = 41513, -- Reins of the Cobalt Netherwing Drake
	[41516] = 41513, -- Reins of the Purple Netherwing Drake
	[41517] = 41513, -- Reins of the Veridian Netherwing Drake
	[41518] = 41513, -- Reins of the Violet Netherwing Drake
	[59567] = 59567, -- Reins of the Azure Drake
	[59568] = 59567, -- Reins of the Blue Drake
	[59569] = 59567, -- Reins of the Bronze Drake
	[59570] = 59567, -- Reins of the Red Drake
	[59571] = 59567, -- Reins of the Twilight Drake
	[59650] = 59567, -- Reins of the Black Drake
	[60025] = 59567, -- Reins of the Albino Drake
	[59961] = 59961, -- Reins of the Red Proto-Drake
	[59996] = 59961, -- Reins of the Blue Proto-Drake
	[60002] = 59961, -- Reins of the Time-Lost Proto-Drake
	[61294] = 59961, -- Reins of the Green Proto-Drake
	[61309] = 61309, -- Magnificent Flying Carpet
	[61451] = 61309, -- Flying Carpet
	[75596] = 61309, -- Frosty Flying Carpet
	
}
